#define HALT 0
#define NOP 1
/*#define TRAP 9*/
#define WRITE 9
#define WRINT 0
#define WRCH 1

#define ADDI 16
#define ANDI 17
#define ORI  18
#define XORI 19
#define SUBI 20
#define RORI 21
#define SRLI 22
#define SRAI 23

#define SUB_NEG 12
#define SUB 0
#define NEG 3

#define NOT 25

#define ALU 8
#define ADD 0
#define AND 1
#define OR  2
#define XOR 3

#define SHIFT 13
#define ROR 1
#define SRL 2
#define SRA 3

#define LDI 26
#define STI 27
#define LD 10
#define ST 11
#define LUI 2
#define LLI 3
#define LDPLUS 31

#define BEQZ 6
#define BNEZ 7
#define BLEZ 14
#define BLTZ 15
#define BDNE 30

#define RET 24
#define JUMP 4
#define JAL 5
#define JR 28
#define JALR 29
